MM = LibStub("AceAddon-3.0"):NewAddon("MikaMounter","AceConsole-3.0","AceEvent-3.0");
local AceLocale = LibStub("AceLocale-3.0");
local L = AceLocale:GetLocale("MikaMounter");
MikaMounterPrefs = {
	dislikes = {},
	favourites = {},
	favouritesActive = false,
	dislikesActive = false
}
MikaMounterGlobalPrefs = {
	mountgroups = {
		[1] = {
			mounts = {
			}
		},
		[2] = {
			mounts = {
			}
		},
		[3] = {
			mounts = {
			}
		},
		[4] = {
			mounts = {
			}
		},
		[5] = {
			mounts = {
			}
		}
	}
}
BINDING_HEADER_MIKA_MOUNTER = "Mika Mounter";
BINDING_NAME_MOUNT_AUTO = L["Flying or ground mount"];
BINDING_NAME_MOUNT_GROUND = L["Ground mount"];
BINDING_NAME_MOUNT_GROUP1 = L["Mount group 1"];
BINDING_NAME_MOUNT_GROUP2 = L["Mount group 2"];
BINDING_NAME_MOUNT_GROUP3 = L["Mount group 3"];
BINDING_NAME_MOUNT_GROUP4 = L["Mount group 4"];
BINDING_NAME_MOUNT_GROUP5 = L["Mount group 5"];
BINDING_NAME_MOUNT_DISMOUNT = L["Dismount"];

walkRidingMounts = {
	30174, -- Riding Turtle
}
qirajRidingMounts = {
	25953, -- Blue Qiraji Battle Tank
	26054, -- Red Qiraji Battle Tank
	26055, -- Yellow Qiraji Battle Tank
	26056, -- Green Qiraji Battle Tank
	26656, -- Black Qiraji Battle Tank
}

-- FKA 60%/100% Mounts
groundMounts = {
	458, -- Brown Horse
	459, -- Gray Wolf
	468, -- White Stallion
	470, -- Black Stallion
	472, -- Pinto
	578, -- Black Wolf
	579, -- Red Wolf
	580, -- Timber Wolf
	581, -- Winter Wolf
	5784, -- Summon Felsteed
	6648, -- Chestnut Mare
	6653, -- Dire Wolf
	6654, -- Brown Wolf
	6777, -- Gray Ram
	6896, -- Black Ram
	6898, -- White Ram
	6899, -- Brown Ram
	8394, -- Striped Frostsaber
	8395, -- Emerald Raptor
	8980, -- Skeletal Horse
	10789, -- Spotted Frostsaber
	10790, -- Tiger
	10793, -- Striped Nightsaber
	10795, -- Ivory Raptor
	10796, -- Turquoise Raptor
	10799, -- Violet Raptor
	10873, -- Red Mechanostrider
	10969, -- Blue Mechanostrider
	13769, -- Summon Warhorse (Alliance)
	13819, -- Warhorse
	15780, -- Green Mechanostrider
	15779, -- White Mechanostrider Mod B
	16055, -- Black Nightsaber
	16056, -- Ancient Frostsaber
	16080, -- Red Wolf
	16081, -- Winter Wolf
	16082, -- Palomino
	16083, -- White Stallion
	16084, -- Mottled Red Raptor
	17229, -- Winterspring Frostsaber
	17450, -- Ivory Raptor
	17453, -- Green Mechanostrider
	17454, -- Unpainted Mechanostrider
	17458, -- Fluorescent Green Mechanostrider
	17459, -- Icy Blue Mechanostrider Mod A
	17460, -- Frost Ram
	17461, -- Black Ram
	17462, -- Red Skeletal Horse
	17463, -- Blue Skeletal Horse
	17464, -- Brown Skeletal Horse
	17465, -- Green Skeletal Warhorse
	17481, -- Rivendare's Deathcharger
	18363, -- Riding Kodo
	18922, -- Teal Kodo
	18989, -- Gray Kodo
	18990, -- Brown Kodo
	18991, -- Green Kodo
	18992, -- Teal Kodo
	22717, -- Black War Steed
	22718, -- Black War Kodo
	22719, -- Black Battlestrider
	22720, -- Black War Ram
	22721, -- Black War Raptor
	22722, -- Red Skeletal Warhorse
	22723, -- Black War Tiger
	22724, -- Black War Wolf
	23161, -- Summon Dreadsteed
	23214, -- Summon Charger (Alliance)
	23219, -- Swift Mistsaber
	23221, -- Swift Frostsaber
	23222, -- Swift Yellow Mechanostrider
	23223, -- Swift White Mechanostrider
	23225, -- Swift Green Mechanostrider
	23227, -- Swift Palomino
	23228, -- Swift White Steed
	23229, -- Swift Brown Steed
	23238, -- Swift Brown Ram
	23239, -- Swift Gray Ram
	23240, -- Swift White Ram
	23241, -- Swift Blue Raptor
	23242, -- Swift Olive Raptor
	23243, -- Swift Orange Raptor
	23246, -- Purple Skeletal Warhorse
	23247, -- Great White Kodo
	23248, -- Great Grey Kodo
	23249, -- Great Brown Kodo
	23250, -- Swift Brown Wolf
	23251, -- Swift Timber Wolf
	23252, -- Swift Gray Wolf
	23338, -- Swift Stormsaber
	23509, -- Frostwolf Howler
	23510, -- Stormpike Battle Charger
	24242, -- Swift Razzashi Raptor
	24252, -- Swift Zulian Tiger
	25863, -- Black Qiraji Battle Tank
	26655, -- Black Qiraji Battle Tank
	33630, -- Blue Mechanostrider
	33660, -- Swift Pink Hawkstrider
	34406, -- Brown Elekk
	34767, -- Summon Charger (Horde)
	34769, -- Summon Warhorse (Horde)
	34790, -- Dark War Talbuk
	34795, -- Red Hawkstrider
	34896, -- Cobalt War Talbuk
	34897, -- White War Talbuk
	34898, -- Silver War Talbuk
	34899, -- Tan War Talbuk
	35018, -- Purple Hawkstrider
	35020, -- Blue Hawkstrider
	35022, -- Black Hawkstrider
	35025, -- Swift Green Hawkstrider
	35027, -- Swift Purple Hawkstrider
	35028, -- Swift Warstrider
	35710, -- Gray Elekk
	35711, -- Purple Elekk
	35712, -- Great Green Elekk
	35713, -- Great Blue Elekk
	35714, -- Great Purple Elekk
	36702, -- Fiery Warhorse
	39315, -- Cobalt Riding Talbuk
	39316, -- Dark Riding Talbuk
	39317, -- Silver Riding Talbuk
	39318, -- Tan Riding Talbuk
	39319, -- White Riding Talbuk
	41252, -- Raven Lord
	42776, -- Spectral Tiger
	42777, -- Swift Spectral Tiger
	43688, -- Amani War Bear
	43899, -- Brewfest Ram
	43900, -- Swift Brewfest Ram
	46628, -- Swift White Hawkstrider
	48025, -- Headless Horsemans Mount
	48027, -- Black War Elekk
	48778, -- Acherus Deathcharger
	48954, -- Swift Zhevra
	49322, -- Swift Zhevra
	49378, -- Brewfest Riding Kodo
	49379, -- Great Brewfest Kodo
	50869, -- Brewfest Kodo
	51412, -- Big Battle Bear
	54753, -- White Polar Bear Mount
	55531, -- Mechano-Hog
	58983, -- Big Blizzard Bear
	59572, -- Black Polar Bear
	59785, -- Black War Mammoth (Alliance)
	59788, -- Black War Mammoth (Horde)
	59791, -- Wooly Mammoth (Alliance)
	59793, -- Wooly Mammoth (Horde)
	59797, -- Ice Mammoth (Horde)
	59799, -- Ice Mammoth (Alliance)
	60114, -- Armored Brown Bear (Alliance)
	60116, -- Armored Brown Bear (Horde)
	60118, -- Black War Bear (Alliance)
	60119, -- Black War Bear (Horde)
	60136, -- Grand Caravan Mammoth
	60140, -- Grand Caravan Mammoth
	60424, -- Mekgineer's Chopper
	61425, -- Traveler's Tundra Mammoth (Alliance)
	61447, -- Traveler's Tundra Mammoth (Horde)
	61465, -- Grand Black War Mammoth
	61467, -- Grand Black War Mammoth
	61469, -- Grand Ice Mammoth (Horde)
	61470, -- Grand Ice Mammoth (Alliance)
	63232, -- Swift Elwynn Steed
	63635, -- Swift Darkspear Raptor
	63636, -- Swift Ironforge Ram
	63637, -- Swift Darnassian Mistsaber
	63638, -- Turbostrider
	63639, -- Great Azuremyst Elekk
	63640, -- Swift Orgrimmar Wolf
	63641, -- Great Mulgore Kodo
	63642, -- Swift Silvermoon Hawkstrider
	63643, -- Swift Forsaken Warhorse
	64656, -- Blue Skeletal Warhorse
	64657, -- White Kodo
	64658, -- Black Wolf
	64659, -- Venomhide Ravasaur
	64977, -- Black Skeletal Horse
	65637, -- Gread Red Elekk
	65638, -- Swift Moonsaber
	65639, -- Swift Red Hawkstrider
	65640, -- Swift Gray Steed
	65641, -- Great Golden Kodo
	65642, -- Turbostrider
	65643, -- Swift Violet Ram
	65644, -- Swift Purple Raptor
	65645, -- White Skeletal Warhorse
	65646, -- Swift Burgundy Wolf
	65917, -- Magic Rooster
	66090, -- Quel'dorei Steed
	66091, -- Sunreaver Hawkstrider
	66122, -- Magic Rooster
	66123, -- Magic Rooster
	66124, -- Magic Rooster
	66846, -- Ochre Skeletal Warhorse
	66847, -- Striped Dawnsaber
	66906, -- Argent Charger
	67466, -- Argent Warhorse
	68056, -- Swift Horde Wolf
	68057, -- Swift Alliance Steed
	68187, -- Crusader's White Warhorse
	68188, -- Crusader's Black Warhorse
	69820, -- Summon Sunwalker Kodo
	69826, -- Summon Great Sunwalker Kodo
	72286, -- Invincible
	73313, -- Crimson Deathcharger
	73629, -- Summon Exarch's Elekk
	73630, -- Summon Great Exarch's Elekk
	74918, -- Wooly White Rhino
	75614, -- Celestial Steed
	84751, -- Fossilized Raptor
	87090, -- Goblin Trike
	87091, -- Goblin Turbo-Trike
	88748, -- Brown Riding Camel
	88749, -- Tan Riding Camel
	88750, -- Grey Riding Camel
	89520, -- Goblin Mini Hotrod
	90621, -- Golden King
	92155, -- Ultramarine Qiraji Battle Tank
	92231, -- Spectral Steed
	92232, -- Spectral Wolf
	93644, -- Kor'kron Annihilator
	96491, -- Armored Razzashi Raptor
	96499, -- Swift Zulian Panther
	97581, -- Savage Raptor
	98204, -- Amani Battle Bear
	98727, -- Winged Guardian
	100332, -- Vicious War Steed
	100333, -- Vicious War Wolf
	101542, -- Flametalon of Alyzrazor
	101573, -- Swift Shorestrider
	102349, -- Swift Springstrider
	102346, -- Swift Forest Strider
	102350, -- Swift Lovebird
	102488, -- White Riding Camel
	103081, -- Darkmoon Dancing Bear
	103195, -- Mountain Horse
	103196, -- Swift Mountain Horse
	107203, -- Tyrael's Charger
	110051, -- Heart Of The Aspects
	118089, -- Azure Water Strider
	118737, -- Pandaren Kite
	120043, -- Jeweled Onyx Panther
	120395, -- Green Dragon Turtle
	120822, -- Great Red Dragon Turtle
	121836, -- Sapphire Panther
	121837, -- Jade Panther
	121838, -- Ruby Panther
	121839, -- Sunstone Panther
	122708, -- Grand Expedition Yak
	123160, -- Crimson Riding Crane
	123182, -- White Riding Yak
	123886, -- Amber Scorpion
	124659, -- Imperial Quilen
	126507, -- Depleted-Kyparium Rocket
	127174, -- Azure Riding Crane
	127176, -- Golden Riding Crane
	127177, -- Regal Riding Crane
	127178, -- Jungle Riding Crane
	127180, -- Albino Riding Crane
	127209, -- Black Riding Yak
	127213, -- Brown Riding Yak
	127216, -- Grey Riding Yak
	127220, -- Blonde Riding Yak
	127268, -- Black Dragon Turtle
	127271, -- Crimson Water Strider
	127272, -- Orange Water Strider
	127274, -- Jade Water Strider
	127278, -- Golden Water Strider
	127286, -- Black Dragon Turtle
	127287, -- Blue Dragon Turtle
	127288, -- Brown Dragon Turtle
	127289, -- Purple Dragon Turtle
	127290, -- Red Dragon Turtle
	127293, -- Great Green Dragon Turtle
	127295, -- Great Black Dragon Turtle
	127298, -- Purple Dragon Turtle
	127302, -- Great Blue Dragon Turtle
	127308, -- Great Brown Dragon Turtle
	127310, -- Great Purple Dragon Turtle
	129932, -- Green Shado-Pan Riding Tiger
	129934, -- Blue Shado-Pan Riding Tiger
	129935, -- Red Shado-Pan Riding Tiger
	130086, -- Brown Riding Goat
	130092, -- Red Flying Cloud
	130137, -- White Riding Goat
	130138, -- Black Riding Goat
	130965, -- Son of Galleon
	130985, -- Pandaren Kite
	134359, -- Sky Golem
	134573, -- Swift Windsteed
	135416, -- Grand Armored Gryphon
	135418, -- Grand Armored Wyvern
	136163, -- Grand Gryphon
	136164, -- Grand Wyvern
	136471, -- Spawn of Horridon
	138423, -- Cobalt Primordial Direhorn
	138424, -- Amber Primordial Direhorn
	138425, -- Slate Primordial Direhorn
	138426, -- Jade Primordial Direhorn
	138640, -- Bone-White Primal Raptor
	138641, -- Red Primal Raptor
	138642, -- Black Primal Raptor
	138643, -- Green Primal Raptor
	140249, -- Golden Primal Direhorn
	140250, -- Crimson Primal Direhorn
	142073, -- Hearthsteed
	142641, -- Brawler's Burly Mushan Beast
	142910, -- Ironbound Wraithcharger
	146615, -- Vicious Warsaber
	146622, -- Vicious Skeletal Warhorse
	148396, -- Kor'kron War Wolf
	148417, -- Kor'kron Juggernaut
	148428, -- Ashhide Mushan Beast
	148970, -- Felsteed
	148972, -- Dreadsteed
	163024, -- Warforged Nightmare
	163025, -- Grinning Reaver
	169952, -- Creeping Carpet
	170347, -- Core Hound
	171436, -- Gorestrider Gronnling
	171616, -- Witherhide Cliffstomper
	171617, -- Trained Icehoof
	171619, -- Tundra Icehoof
	171620, -- Bloodhoof Bull
	171621, -- Ironhoof Destroyer
	171622, -- Mottled Meadowstomper
	171623, -- Trained Meadowstomper
	171624, -- Shadowhide Pearltusk
	171625, -- Dusty Rockhide
	171626, -- Armored Irontusk
	171627, -- Blacksteel Battleboar
	171628, -- Rocktusk Battleboar
	171629, -- Armored Frostboar
	171630, -- Armored Razorback
	171632, -- Frostplains Battleboar
	171633, -- Wild Goretusk
	171634, -- Domesticated Razorback
	171635, -- Giant Coldsnout
	171636, -- Great Greytusk
	171637, -- Trained Rocktusk
	171638, -- Trained Riverwallow
	171824, -- Sapphire Riverbeast
	171825, -- Mosshide Riverwallow
	171826, -- Mudback Riverbeast
	171827, -- Hellfire Infernal
	171829, -- Shadowmane Charger
	171830, -- Swift Breezestrider
	171831, -- Trained Silverpelt
	171832, -- Breezestrider Stallion
	171833, -- Pale Thorngrazer
	171834, -- Vicious War Ram
	171835, -- Vicious War Raptor
	171836, -- Garn Steelmaw
	171837, -- Warsong Direfang
	171838, -- Armored Frostwolf
	171839, -- Ironside Warwolf
	171841, -- Trained Snarler
	171842, -- Swift Frostwolf
	171843, -- Smoky Direwolf
	171844, -- Dustmane Direwolf
	171845, -- Warlord's Deathwheel
	171846, -- Champion's Treadblade
	171847, -- Cindermane Charger
	171848, -- Challenger's War Yeti
	171849, -- Sunhide Gronnling
	171850, -- Llothien Prowler
	171851, -- Garn Nighthowl
	-- 179244, -- Chauffeured Mechano-Hog
	-- 179245, -- Chauffeured Mekgineer's Chopper
	179478, -- Voidtalon of the Dark Star
	180545, -- Mystic Runesaber
	182912, -- Felsteel Annihilator
	183889, -- Vicious War Mechanostrider
	185052, -- Vicious War Kodo
	186305, -- Infernal Direwolf
	186828, -- Primal Gladiator's Felblood Gronnling
	189043, -- Wild Gladiator's Felblood Gronnling
	189044, -- Warmongering Gladiator's Felblood Gronnling
	189364, -- Coalfist Gronnling
	189998, -- Illidari Felstalke
	190690, -- Bristling Hellboar
	190977, -- Deathtusk Felboar
	191314, -- Minion of Grumpus
	193007, -- Grove Defiler
	193695, -- Prestigious War Steed
	196681, -- Spirit of Eche'ro
	200175, -- Felsaber
	204166, -- Prestigious War Wolf
	213134, -- Felblaze Infernal
	213158, -- Predatory Bloodgazer
	213163, -- Snowfeather Hunter
	213164, -- Brilliant Direbeak
	213165, -- Viridian Sharptalon
	213209, -- Steelbound Devourer
	213339, -- Great Northern Elderhorn
	213350, -- Frostshard Infernal
	215558, -- Ratstallion
	222202, -- Prestigious Bronze Courser
	222236, -- Prestigious Royal Courser
	222237, -- Prestigious Forest Courser
	222238, -- Prestigious Ivory Courser
	222240, -- Prestigious Azure Courser
	222241, -- Prestigious Midnight Courser
	223341, -- Vicious Gilnean Warhorse
	223354, -- Vicious War Trike
	223363, -- Vicious Warstrider
	223578, -- Vicious War Elekk
	223814, -- Mechanized Lumber Extractor
	227956, -- Arcadian War Turtle
	229486, -- Vicious War Bear
	229487, -- Vicious War Bear
	229499, -- Midnight
	229512, -- Vicious War Lion
	230401, -- Ivory Hawkstrider
	230844, -- Brawler's Burly Basilisk
	230987, -- Arcanist's Manasaber
	230988, -- Vicious War Scorpion
	232405, -- Primal Flamesaber
	232523, -- Vicious War Turtle
	232525, -- Vicious War Turtle
	237286, -- Dune Scavenger
	237287, -- Alabaster Hyena
	237288, -- Onyx War Hyena
	239049, -- Obsidian Krolusk
	239766, -- Blue Qiraji War Tank
	239767, -- Red Qiraji War Tank
	239770, -- Black Qiraji War Tank
	242305, -- Sable Ruinstrider
	242874, -- Highmountain Elderhorn
	242875, -- Wild Dreamrunner
	242896, -- Vicious War Fox
	242897, -- Vicious War Fox
	243512, -- Luminous Starseeker
	243651, -- Shackled Ur'zul
	243652, -- Vile Fiend
	243795, -- Leaping Veinseeker
	244457, -- Default AI Mount Record
	247402, -- Lucid Nightmare
	250735, -- Bloodgorged Crawg
	253004, -- Amethyst Ruinstrider
	253005, -- Beryl Ruinstrider
	253006, -- Russet Ruinstrider
	253007, -- Cerulean Ruinstrider
	253008, -- Umber Ruinstrider
	253058, -- Maddened Chaosrunner
	253660, -- Biletooth Gnasher
	253661, -- Crimson Slavermaw
	253662, -- Acid Belcher
	254069, -- Glorious Felcrusher
	254258, -- Blessed Felcrusher
	254259, -- Avenging Felcrusher
	254260, -- Bleakhoof Ruinstrider
	255695, -- Seabraid Stallion
	255696, -- Gilded Ravasaur
	
	258022, -- Lightforged Felcrusher (Lightforged Draenei unlock Mount)
	258060, -- Highmountain Thunderhoof (Highmountain Tauren unlock Mount)
	258845, -- Nightborne Manasaber (Nightborne Elf unlock Mount)
	259202, -- Starcursed Voidstrider (Void Elf unlock Mount)
	259213, -- Admiralty Stallion
	259740, -- Green Marsh Hopper
	260172, -- Dapple Gray
	260173, -- Smoky Charger
	260174, -- Terrified Pack Mule
	260175, -- Goldenmane
	261433, -- Vicious War Basilisk
	261434, -- Vicious War Basilisk
	263707, -- Zandalari Direhorn
	264058, -- Mighty Caravan Brutosaur
	266058, -- Tomb Stalker
	267270, -- Kua'fon
	267274, -- Mag'har Direwolf
	270560, -- Vicious War Clefthoof
	270562, -- Darkforge Ram
	270564, -- Dawnforge Ram
	271646, -- Dark Iron Core Hound
	272481, -- Vicious War Riverbeast
	273541, -- Underrot Crawg
	275837, -- Cobalt Pterrordax
	275841, -- Expedition Bloodswarmer
	279456, -- Highland Mustang
	279457, -- Broken Highland Mustang
	279467, -- Craghorn Chasm-Leaper
	279474, -- Palehide Direhorn
	279569, -- Swift Albino Raptor
	279608, -- Lil' Donkey
	279611, -- Skullripper
	280729, -- Frenzied Feltalon
	280730, -- Pureheart Courser
	281044, -- Prestigious Bloodforged Courser
	281554, -- Meat Wagon
	281887, -- Vicious Black Warsaber
	281890, -- Vicious Black Bonesteed
	282682, -- Kul Tiran Charger
	288438, -- Blackpaw
	288499, -- Frightened Kodo
	288503, -- Umber Nightsaber
	288505, -- Kaldorei Nightsaber
	288587, -- Blue Marsh Hopper
	288589, -- Yellow Marsh Hopper
	288712, -- Stonehide Elderhorn
	288722, -- Risen Mare
	288735, -- Rubyshell Krolusk
	288736, -- Azureshell Krolusk
	289639, -- Bruce
	290608, -- Crusader's Direhorn
	291492, -- Rusty Mechanocrawler
	294038, -- Royal Snapdragon
	294039, -- Snapback Scuttler
	294143, -- X-995 Mechanocat
	294568, -- Beastlord's Irontusk
	294569, -- Beastlord's Warwolf
	295386, -- Ironclad Frostclaw
	295387, -- Bloodflank Charger
	296788, -- Mechacycle Model W
	297157, -- Junkheap Drifter
	297560, -- Child of Torcali
	299158, -- Mechagon Peacekeeper
	299159, -- Scrapforged Mechaspider
	300146, -- Snapdragon Kelpstalker
	300147, -- Deepcoral Snapdragon
	306421, -- Frostwolf Snarler
	307263, -- Explorer's Dunetrekker
	308250, -- Stormpike Battle Ram
}
-- FKA 150%, 280% then 310% Mounts
flyingMounts = {
	28828, -- Nether Drake
	32235, -- Golden Gryphon
	32239, -- Ebon Gryphon
	32240, -- Snowy Gryphon
	32242, -- Swift Blue Gryphon
	32243, -- Tawny Wind Rider
	32244, -- Blue Wind Rider
	32245, -- Green Wind Rider
	32246, -- Swift Red Wind Rider
	32289, -- Swift Red Gryphon
	32290, -- Swift Green Gryphon
	32292, -- Swift Purple Gryphon
	32295, -- Swift Green Wind Rider
	32296, -- Swift Yellow Wind Rider
	32297, -- Swift Purple Wind Rider
	37015, -- Swift Nether Drake
	39798, -- Green Nether Ray
	39800, -- Red Nether Ray
	39801, -- Purple Nether Ray
	39802, -- Silver Nether Ray
	39803, -- Blue Nether Ray
	40192, -- Ashes of Al'ar
	41513, -- Onyx Nether Drake
	41514, -- Azure Nether Drake
	41515, -- Cobalt Nether Drake
	41516, -- Purple Nether Drake
	41517, -- Veridian Nether Drake
	41518, -- Violet Nether Drake
	43810, -- Frost Wyrm
	43927, -- Cenarion War Hippogryph
	44151, -- Turbo-Charged Flying Machine
	44153, -- Flying Machine
	44317, -- Merciless Nether Drake
	44744, -- Merciless Nether Drake
	46197, -- X-51 Nether-Rocket
	46199, -- X-51 Nether-Rocket X-TREME
	48025, -- Headless Horsemans Mount
	49193, -- Vengeful Nether Drake
	51960, -- Frostwyrm
	54729, -- Winged Steed of the Ebon Blade
	55164, -- Swift Spectral Gryphon
	58615, -- Brutal Nether Drake
	59567, -- Azure Drake (Maly 25)
	59568, -- Blue Drake (Maly 10)
	59569, -- Bronze Drake
	59570, -- Red Drake (Wyrmrest Accord)
	59571, -- Twilight Drake (Sartharion hard mode 25-man)
	59650, -- Black Drake (Sartharion hard mode 10-man)
	59961, -- Red Proto-Drake (Glory of the Hero)
	59976, -- Black Proto-Drake (Glory of the Heroic Raider)
	59996, -- Blue Proto-Drake
	60002, -- Time-Lost Proto-Drake
	60021, -- Plagued Proto-Drake (Glory of the Raider)
	60024, -- Violet Proto-Drake (What A Strange Trip It Has Been)
	60025, -- Albino Drake
	61229, -- Armored Snowy Gryphon
	61230, -- Armored Blue Wind Rider
	61294, -- Green Proto-Drake
	61309, -- Magnificent Flying Carpet
	61451, -- Flying Carpet
	61996, -- Blue Dragonhawk
	61997, -- Red Dragonhawk
	62042, -- Black Dragonhawk
	62048, -- Black Dragonhawk Mount
	63796, -- Mimiron's Head
	63844, -- Argent Hippogryph
	63956, -- Ironbound Proto-Drake (Heroic Ulduar Raider)
	63963, -- Rusted Proto-Drake (Ulduar Raider)
	64927, -- Deadly Gladiator's Frost Wyrm
	65439, -- Furious Gladiator's Frost Wyrm
	66087, -- Silver Covenant Hippogryph
	66088, -- Sunreaver Dragonhawk
	67336, -- Ruthless Gladiator's Frost Wyrm
	69395, -- Onyxian Drake
	71342, -- Big Love Rocket
	71810, -- Wrathful Gladiator's Frost Wyrm
	72286, -- Invincible
	72807, -- Icebound Frostbrood Vanquisher
	72808, -- Bloodbathed Frostblood Vanquisher
	74856, -- Blazing Hippogryph
	75614, -- Celestial Steed
	75596, -- Frosty Flying Carpet
	75973, -- X-53 Touring Rocket
	88331, -- Volcanic Stone Drake
	88335, -- Drake of the East Wind
	88718, -- Phosphorescent Stone Drake
	88741, -- Drake of the West Wind
	88742, -- Drake of the North Wind
	88744, -- Drake of the South Wind
	88746, -- Vitreous Stone Drake
	88990, -- Dark Phoenix
	93326, -- Sandstone Drake
	93463, -- Mottled Drake
	93623, -- Mottled Drake
	96503, -- Amani Dragonhawk
	97359, -- Flameward Hippogryph
	97493, -- Crimson Fire Hawk
	97501, -- Beryl Fire Hawk
	97560, -- Corrupted Fire Hawk
	98727, -- Winged Guardian
	101282, -- Vicious Gladiator's Twilight Drake
	101821, -- Ruthless Gladiator's Twilight Drake
	102514, -- Corrupted Hippogryph
	107203, -- Tyrael's Charger
	107516, -- Spectral Gryphon
	107517, -- Spectral Wind Rider
	107842, -- Blazing Drake
	107844, -- Twilight Harbinger
	107845, -- Life-Binder's Handmaiden
	110039, -- Experiment 12-B
	110051, -- Heart Of The Aspects
	113120, -- Feldrake
	113199, -- Jade Cloud Serpent
	118737, -- Pandaren Kite
	121820, -- Obsidian Nightwing
	123992, -- Azure Cloud Serpent
	123993, -- Golden Cloud Serpent
	124408, -- Thundering Jade Cloud Serpent
	124550, -- Cataclysmic Gladiator's Twilight Drake
	124659, -- Imperial Quilen
	126507, -- Depleted-Kyparium Rocket
	126508, -- Geosynchronous World Spinner
	127154, -- Onyx Cloud Serpent
	127156, -- Crimson Cloud Serpent
	127158, -- Heavenly Onyx Cloud Serpent
	127161, -- Heavenly Crimson Cloud Serpent
	127164, -- Heavenly Golden Cloud Serpent
	127165, -- Heavenly Jade Cloud Serpent
	127169, -- Heavenly Azure Cloud Serpent
	127170, -- Astral Cloud Serpent
	129552, -- Crimson Pandaren Phoenix
	129918, -- Thundering August Cloud Serpent
	130092, -- Red Flying Cloud
	130985, -- Pandaren Kite
	132036, -- Thundering Ruby Cloud Serpent
	132117, -- Ashen Pandaren Phoenix
	132118, -- Emerald Pandaren Phoenix
	132119, -- Violet Pandaren Phoenix
	133023, -- Jade Pandaren Kite
	134359, -- Sky Golem
	134573, -- Swift Windsteed
	135416, -- Grand Armored Gryphon
	135418, -- Grand Armored Wyvern
	136163, -- Grand Gryphon
	136164, -- Grand Wyvern
	136400, -- Armored Skyscreamer
	136505, -- Ghastly Charger
	139407, -- Malevolent Gladiator's Cloud Serpent
	139442, -- Thundering Cobalt Cloud Serpent
	139448, -- Clutch of Ji-Kun
	139595, -- Armored Bloodwing
	142266, -- Armored Red Dragonhawk
	142073, -- Hearthsteed
	142478, -- Armored Blue Dragonhawk
	142878, -- Enchanted Fey Dragon
	148392, -- Spawn of Galakras
	148476, -- Thundering Onyx Cloud Serpent
	148618, -- Tyrannical Gladiator's Cloud Serpent
	148619, -- Grievous Gladiator's Cloud Serpent
	148620, -- Prideful Gladiator's Cloud Serpent
	149801, -- Emerald Hippogryph
	153489, -- Iron Skyreaver
	155741, -- Dread Raven
	163024, -- Warforged Nightmare
	171828, -- Solar Spirehawk
	175700, -- Emerald Drake
	183117, -- Corrupted Dreadwing
	189999, -- Grove Warden
	191633, -- Soaring Skyterror
	194046, -- Swift Spectral Rylak
	194464, -- Eclipse Dragonhawk
	201098, -- Infinite Timereaver
	213115, -- Bloodfang Widow
	215159, -- Long-Forgotten Hippogryph
	215545, -- Fel Bat (Test)
	223814, -- Mechanized Lumber Extractor
	225765, -- Leyfeather Hippogryph
	227986, -- Vindictive Gladiator's Strom Dragon
	227988, -- Fearless Gladiator's Strom Dragon
	227989, -- Cruel Gladiator's Strom Dragon
	227991, -- Ferocious Gladiator's Strom Dragon
	227994, -- Fierce Gladiator's Strom Dragon
	227995, -- Demonic Gladiator's Strom Dragon
	229376, -- Archmage's Prismatic Disc
	229377, -- high Priest's Lightsworn Seeker
	229385, -- Ban-Lu, Grandmaster's Companion
	229386, -- Huntmaster's Loyal Wolfhawk
	229387, -- Deathlord's Vilebrood Vanquisher
	229388, -- Battlelord's Bloodthirsty War Wyrm
	229417, -- Slayer's Felbroken Shrieker
	229438, -- Huntmaster's Fierce Wolfhawk
	229439, -- Huntmaster's Dire Wolfhawk
	230987, -- Arcanist's Manasaber
	231428, -- Smoldering Ember Wyrm
	231434, -- Shadowblade's Murderous Omen
	231435, -- Highlord's Golden Charger
	231442, -- Farseer's Raging Tempest
	231523, -- Shadowblade's Lethal Omen
	231524, -- Shadowblade's Baneful Omen
	231525, -- Shadowblade's Crimson Omen
	231587, -- Highlord's Vengeful Charger
	231588, -- Highlord's Vigilant Charger
	231589, -- Highlord's Valorous Charger
	232412, -- Netherlord's Chaotic Wrathsteed
	232519, -- Abyss Worm
	233364, -- Leywoven Flying Carpet
	235764, -- Darkspore Mana Ray
	238452, -- Netherlord's Brimstone Wrathsteed
	238454, -- Netherlord's Accursed Wrathsteed
	239013, -- Lightforged Warframe
	239363, -- Swift Spectral Hippogryph
	242881, -- Cloudwing Hippogryph
	242882, -- Valarjar Stormwing
	243025, -- Riddler's Mind-Worm
	243201, -- Demonic Gladiator's Storm Dragon
	244712, -- Spetral Pterrorwing
	245723, --- Stormwind Skychaser
	245725, --- Orgrimmar Interceptor
	247448, -- Darkmoon Dirigible
	253087, -- Antoran Charhound
	253088, -- Antoran Gloomhound
	253106, -- Vibrant Mana Ray
	253107, -- Lambent Mana Ray
	253108, -- Felglow Mana Ray
	253109, -- Scintillating Mana Ray
	253639, -- Violet Spellwing
	254811, -- Squawks
	254813, -- Sharkbait
	256123, -- Xiwyllag ATV
	259395, -- Shu-zen, the Divine Sentinel
	259741, -- Honeyback Harvester
	261395, -- The Hivemind
	261437, -- Mecha-Mogul Mk2
	262022, -- Dread Gladiator's Proto-Drake
	262023, -- Sinister Gladiator's Proto-Drake
	262024, -- Notorious Gladiator's Proto-Drake
	266925, -- Siltwing Albatross
	272472, -- Undercity Plaguebat
	272770, -- The Dreadwake
	274610, -- Teldrassil Hippogryph
	275623, -- Nazjatar Blood Serpent
	275840, -- Voldunai Dunescraper
	275859, -- Dusky Waycrest Gryphon
	275838, -- Captured Swampstalker
	275866, -- Stormsong Coastwatcher
	275868, -- Proudmoore Sea Scout
	279454, -- Conqueror's Scythemaw
	279466, -- Twilight Avenger
	279469, -- Qinsho's Eternal Hound
	279868, -- Witherbark Direwing
	288495, -- Ashenvale Chimaera
	288714, -- Bloodthirsty Dreadwing
	288720, -- Bloodgorged Hunter
	288721, -- Island Thunderscale
	288740, -- Priestess' Moonsaber
	289083, -- G.M.O.D.
	289101, -- Dazar'alor Windreaver
	289555, -- Glacial Tidestorm
	290132, -- Syverian Dreamer
	290133, -- Vulpine Familiar
	290134, -- Hogrus, Swine of Good Fortune
	290328, -- Wonderwing 2.0
	290718, -- Aerial Unit R-21/X
	291538, -- Unshackled Waveray
	292407, -- Ankoan Waveray
	292419, -- Azshari Bloatray
	294197, -- Obsidian Worldbreaker
	299170, -- Rustbolt Resistor
	300149, -- Silent Glider
	307256, -- Explorer's Jungle Hopper
	302361, -- Alabaster Stormtalon
	302362, -- Alabaster Thunderwing
	302794, -- Swift Spectral Fathom Ray
	302795, -- Swift Spectral Magnetocraft
	302796, -- Swift Spectral Armored Gryphon
	302797, -- Swift Spectral Pterrordax
	307932, -- Enscrolled Everwyrm
}

skillMounts = {
	[44151] = L['Engineering'], -- Turbo-Charged Flying Machine - Engineer Only
	[44153] = L['Engineering'], -- Flying Machine - Engineer Only
	-- [134359] = L['Engineering'], -- Sky Golem
	
	
	[61309] = L['Tailoring'], -- Magnificent Flying Carpet - Tailor Only
	[61451] = L['Tailoring'], -- Flying Carpet - Tailor Only
	[75596] = L['Tailoring'], -- Frosty Flying Carpet - Tailor Only
	[118737] = L['Tailoring'], -- Pandaren Kite - Tailor Only
	[130985] = L['Tailoring'], -- Pandaren Kite - Tailor Only
	[169952] = L['Tailoring'], -- Creeping Carpet - Tailor Only
	
	[171844] = L['Leatherworking'], -- Dustmane Direwolf - Leatherworking Only


	-- Serpent Riding has been removed around 7.0
	-- [113199] = L['Cloud Serpent Riding'], -- Jade Cloud Serpent
	-- [123992] = L['Cloud Serpent Riding'], -- Azure Cloud Serpent
	-- [123993] = L['Cloud Serpent Riding'], -- Golden Cloud Serpent
	-- [124408] = L['Cloud Serpent Riding'], -- Thundering Jade Cloud Serpent
	-- [127154] = L['Cloud Serpent Riding'], -- Onyx Cloud Serpent
	-- [127156] = L['Cloud Serpent Riding'], -- Crimson Cloud Serpent
	-- [127158] = L['Cloud Serpent Riding'], -- Heavenly Onyx Cloud Serpent
	-- [127161] = L['Cloud Serpent Riding'], -- Heavenly Crimson Cloud Serpent
	-- [127164] = L['Cloud Serpent Riding'], -- Heavenly Golden Cloud Serpent
	-- [127165] = L['Cloud Serpent Riding'], -- Heavenly Jade Cloud Serpent
	-- [127169] = L['Cloud Serpent Riding'], -- Heavenly Azure Cloud Serpent
	-- [127170] = L['Cloud Serpent Riding'], -- Astral Cloud Serpent
	-- [129918] = L['Cloud Serpent Riding'], -- Thundering August Cloud Serpent
	-- [132036] = L['Cloud Serpent Riding'], -- Thundering Ruby Cloud Serpent
	-- [233364] = L['Tailoring'], -- Leywoven Flying Carpet - Tailor Only
	
}

-- AKA "I can't ride"
chauffeuredMounts = {
	179244, -- Chauffeured Mechano-Hog
	179245, -- Chauffeured Mekgineer's Chopper
}

-- AKA "The Achievement Turtle"
waterMounts = {
	64731, -- Sea Turtle
	98718, -- Subdued Seahorse
	223018, -- Fathom Dweller
	228919, -- Darkwater Skate
	214791, -- Brinedeep Bottom-Feeder
	253711, -- Pond Nettle
	278803, -- Great Sea Ray
	278979, -- Surf Jelly
	288711, -- Saltwater Seahorse
	300150, -- Fabious
	300151, -- Inkscale Deepseeker
	300153, -- Crimson Tidestallion
}
-- AKA "Abyssal Seahorse"
fastWaterMounts = {
	75207, -- Abyssal Seahorse / Vashj'ir Seahorse
}
-- Vashj'ir
deepWaterZones = {
	L["Shimmering Expanse"],
	L["Abyssal Depths"],
	L["Kelp'thar Forest"],
	L["Ruins of Vashj'ir"]
	
}
noFlyZones = {
	L["Throne of the Four Winds"],
	L["The Deadmines"],
	L["Dreadscar Rift"],
	L["Niskara"],
	L["The Maelstroem"],
	L["Azuremyst Isle"],
	L["Helheim"],
	L["Grimrail Depot"],
}
noFlyInstances = {
	L["Scarlet Monastery"],
	L["A Brewing Storm"],
	L["Arena of Annihilation"],
	L["Brewmoon Festival"],
	L["Crypt of Forgotten Kings"],
	L["Greenstone Village"],
	L["Theramore's Fall"],
	L["Unga Ingoo"],
	L["Dagger in the Dark"],
	L["Assault on Zan'vess"],
	L["Domination Point"],
	L["Lion's Landing"],
	L["A Little Patience"]
}

continentMap = {
	[12] = 1, -- Kalimdor
	[13] = 2, -- Eastern Kingdoms
	[101] = 3, -- Outland
	[113] = 4, -- Northrend
	[424] = 5, -- Pandaria
	[572] = 6, -- Draenor
	[619] = 7, -- Broken Isles
	[588] = 8, -- Ashran
}

worldPVPZones = {
	Wintergrasp = 1, -- Wintergrasp
	TolBarad = 2, -- Tol Barad
}

MM.options = {
	name = "MikaMounter",
	type = "group",
	handler = MM,
	args = {
		mount = {
			type = "execute",
			name = "Mount random mount",
			desc = L["Mount random mount depending on your location"],
			func = "Mount",
		},
		mountground = {
			type = "execute",
			name = "Mount random ground mount",
			desc = L["Mount random ground mount no matter if you can fly or not"],
			func = "MountGround",
		},
		list = {
			type = "group",
			name = "List items",
			desc = L["List some things"],
			args = {
				mounts = {
					type = "execute",
					name = "List mounts and spell IDs",
					desc = L["List your mounts and summoning spell IDs"],
					func = "ListMounts",
				},
				newmounts = {
					type = "execute",
					name = "List mounts unknown to this addon",
					desc = L["List mounts unknown to this addon"],
					func = "ListUnknownMounts",
				},
				mountcount = {
					type = "execute",
					name = "List mount amounts for each mountgroup",
					desc = L["List mount amounts for each mount group"],
					func = "ListMountAmounts",
				},
				mountgroup = {
					type = "input",
					name = "List mounts for given mountgroup",
					desc = L["List mount group"],
					set = "ListMountGroup",
				},
			},
		},
		toggle = {
			type = "group",
			name = "Toggle flags",
			desc = L["Toggle flags"],
			args = {
				favourite = {
					type = "input",
					name = "Add or remove favourite",
					desc = L["Add or remove favourite"],
					get = "Nothing",
					set = "ToggleFavourite",
				},
				dislike = {
					type = "input",
					name = "Add or remove dislike",
					desc = L["Add or remove dislike"],
					get = "Nothing",
					set = "ToggleDislike",
				},
				favourites = {
					type = "execute",
					name = "Toggle favourites",
					desc = L["Toggle favourites"],
					func = "ToggleFavourites",
				},
				dislikes = {
					type = "execute",
					name = "Toggle dislikes",
					desc = L["Toggle dislikes"],
					func = "ToggleDislikes",
				},
				mountgroup = {
					type = "input",
					name = "Toggle mount group",
					desc = L["Toggle mount group"],
					get = "Nothing",
					set = "ToggleMountGroup",
				},
			}
		},
--		set = {
--			type = "group",
--			name = "Set stuff",
--			desc = L["Set some stuff"],
--			args = {
--				mountgroupname = {
--					type = "input",
--					name = "Set mount group name",
--					desc = L["Set mount group name"],
--					get = "Nothing",
--					set = "SetMountGroupName",
--				},
--			}
--		}
	}
}	

function MM:OnInitialize()
	LibStub("AceConfig-3.0"):RegisterOptionsTable("MikaMounter", MM.options, {"mm", "mikamounter"});
	MM:RegisterEvent("UNIT_INVENTORY_CHANGED");
	MM:RegisterEvent("UNIT_PET");
	MM:RegisterEvent("UNIT_AURA");
	MM:RegisterEvent("UNIT_ENTERED_VEHICLE");
	MM:RegisterEvent("ITEM_LOCK_CHANGED");
	MM:RegisterEvent("ZONE_CHANGED");
	MM.actionbutton = CreateFrame("Button", "MountButton", UIParent, "SecureHandlerShowHideTemplate, SecureHandlerEnterLeaveTemplate, SecureHandlerStateTemplate, SecureActionButtonTemplate");
	MM.actionbutton:RegisterForClicks("LeftButtonDown", "RightButtonDown");
	MM.actionbutton:SetAttribute("type","item");
	MM.actionbutton:Show();
	--MM:RegisterChatCommand("/mikamount", "MM:SlashCommand");
end

function MM:MountGroup(iMountGroup)
	local bIsMounted = MM:Dismount();
	if ( not ( bIsMounted == nil ) ) then
		return bIsMounted;
	else
		local mountNumber = 0;
		local mountTables = {};
		table.insert(mountTables,MikaMounterGlobalPrefs.mountgroups[iMountGroup].mounts);
		local mountTable = {};
		local mountCount = 0;
		local mountNumbers = {};
		for i = 1, table.getn(mountTables) do
			if ( mountCount == 0 ) then
				mountTable = mountTables[i];
				mountNumbers = MM:getMountNumbers(mountTable);
				mountCount = table.getn(mountNumbers);
				if ( mountCount > 0 ) then
					mountNumber = math.floor(math.random() * mountCount + 1);
					if ( mountNumber > mountCount ) then
						mountNumber = mountCount;
					end;
					C_MountJournal.SummonByID(mountNumbers[mountNumber]);
					return true;
				end;
			end;
		end;
	end;
	return false;
end

function MM:MountGround()
	local bIsMounted = MM:Dismount();
	if ( not ( bIsMounted == nil ) ) then
		return bIsMounted;
	else
		local qiraj, walkR, water, fwate, fastR, fastF = MM:getMountAmounts();
		if ( (qiraj+walkR+water+fastR+fastF) == 0 ) then
			-- Keine Mounts, keine Aktion
			return false;
		end;
		local mountNumber = 0;
		local mountTables = {};
		if ( IsSwimming() == true ) then 
			if (MM:findValue(deepWaterZones,GetRealZoneText())) then table.insert(mountTables,MM:IntersectTables(fastWaterMounts)); end;
			table.insert(mountTables,MM:IntersectTables(waterMounts));
		end;
		if ( MM:getRidingSkill() == 0 ) then table.insert(mountTables,MM:IntersectTables(chauffeuredMounts)); end;
		if ( GetRealZoneText() == L["Ahn'Qiraj"] ) then table.insert(mountTables,MM:IntersectTables(qirajRidingMounts)); end;
		table.insert(mountTables,MM:IntersectTables(groundMounts));
		table.insert(mountTables,MM:IntersectTables(walkRidingMounts));
		local mountTable = {};
		local mountCount = 0;
		local mountNumbers = {};
		for i = 1, table.getn(mountTables) do
			if ( mountCount == 0 ) then
				mountTable = mountTables[i];
				mountNumbers = MM:getMountNumbers(mountTable);
				mountCount = table.getn(mountNumbers);
				if ( mountCount > 0 ) then
					mountNumber = math.floor(math.random() * mountCount + 1);
					if ( mountNumber > mountCount ) then
						mountNumber = mountCount;
					end;
					C_MountJournal.SummonByID(mountNumbers[mountNumber]);
					return true;
				end;
			end;
		end;
	end;
	return false;
end

function MM:Mount()
	local bIsMounted = MM:Dismount();
	if ( not ( bIsMounted == nil ) ) then
		return bIsMounted;
	else
		local qiraj, walkR, water, fwate, fastR, fastF = MM:getMountAmounts();
		if ( (qiraj+walkR+water+fastR+fastF) == 0 ) then
			-- Keine Mounts, keine Aktion
			return;
		end;
		local mountNumber = 0;
		mountCount = 0;
		local mountNumbers = {};
		if ( MM:isFlyableArea() == true ) then
			local mountTables = {
				MM:IntersectTables(flyingMounts),
				MM:IntersectTables(groundMounts),
				MM:IntersectTables(walkRidingMounts),
			};
			for i = 1, table.getn(mountTables) do
				if ( mountCount == 0 ) then
					mountNumbers = MM:getMountNumbers(mountTables[i]);
					mountCount = table.getn(mountNumbers);
					if ( mountCount > 0 ) then
						mountNumber = math.floor(math.random() * mountCount + 1);
						if ( mountNumber > mountCount ) then
							mountNumber = mountCount;
						end;
						C_MountJournal.SummonByID(mountNumbers[mountNumber]);
						return true;
					end;
				end;
			end;
		else
			return MM:MountGround();
		end;
	end;
	return false;
end

-- Checks for flight path (leaving at the next stop)
-- Stops here if player is flying (only on normal mount buttons)
-- Dismount from normal mount
-- Leave vehicle (also works on Highmountain quest line, where you are "Vehicled" in Huln or Suramar baskets)
function MM:Dismount(bForceDismount)
	if ( UnitOnTaxi("player") ) then
		TaxiRequestEarlyLanding();
		return true;
	end;
	if ( (bForceDismount == nil) and (IsFlying()) ) then
		return false;
	end;
	if ( ( IsMounted() == true ) or ( CanExitVehicle() == true ) ) then
		if ( IsMounted() ) then
			Dismount();
			return true;
		else
			VehicleExit();
			return true;
		end
	end;
	local className, _, _ = C_PlayerInfo.GetClass(PlayerLocation:CreateFromUnit("player"));
	if ( className == "Druid" ) then
		if ( not ( GetShapeshiftFormID() == nil ) ) then
			CancelShapeshiftForm();
		end;
	end;
	return nil;
end;


function MM:ListMountAmounts()
	local qiraj, walkR, water, fwate, fastR, fastF = MM:getMountAmounts();
	DEFAULT_CHAT_FRAME:AddMessage(qiraj.." "..L["Qiraj Riding Mounts"]);
	DEFAULT_CHAT_FRAME:AddMessage(walkR.." "..L["Walk Riding Mounts"]);
	DEFAULT_CHAT_FRAME:AddMessage(water.." "..L["Water Mounts"]);
	DEFAULT_CHAT_FRAME:AddMessage(fwate.." "..L["fast Water Mounts"]);
	DEFAULT_CHAT_FRAME:AddMessage(fastR.." "..L["Fast Riding Mounts"]);
	DEFAULT_CHAT_FRAME:AddMessage(fastF.." "..L["Fast Flying Mounts"]);
	return (qiraj+walkR+water+fwate+fastR+fastF);
end;

function MM:getMountAmounts()
	local mountListIDs = C_MountJournal.GetMountIDs();
	local qiraj = 0;
	local fastR = 0;
	local fastF = 0;
	local walkR = 0;
	local water = 0;
	local fwate = 0;
	for i = 1 , table.getn(mountListIDs) do
		local creatureName, creatureSpellID, icon, issummoned, isUsable, sourceType, isFavourite, isFactionSpecific, faction, hideOnChar, isCollected, mountID = C_MountJournal.GetMountInfoByID(mountListIDs[i]);
		if ( isCollected ) then
			if ( MM:findValue(qirajRidingMounts,creatureSpellID) ) then
				qiraj = qiraj + 1;
			end;
			if ( MM:findValue(groundMounts,creatureSpellID) ) then
				fastR = fastR + 1;
			end;
			if ( MM:findValue(flyingMounts,creatureSpellID) ) then
				fastF = fastF + 1;
			end;
			if ( MM:findValue(walkRidingMounts,creatureSpellID) ) then
				walkR = walkR + 1;
			end;
			if ( MM:findValue(waterMounts,creatureSpellID) ) then
				water = water + 1;
			end;
			if ( MM:findValue(fastWaterMounts,creatureSpellID) ) then
				fwate = fwate + 1;
			end;
		end;
	end;
	return qiraj, walkR, water, fwate, fastR, fastF;
end;

function MM:getMountNumbers(myMountTable)
	local mountListIDs = C_MountJournal.GetMountIDs();
	local goodNumbers = {};
	local fallbackList = {};
	for i = 1 , table.getn(mountListIDs) do
		local _, creatureSpellID, _, _, isUsable, _, _, isFactionSpecific, faction, _, isCollected, _ = C_MountJournal.GetMountInfoByID(mountListIDs[i]);
		if ( isUsable and isCollected and MM:findValue(myMountTable,creatureSpellID) and MM:hasSkillFor(creatureSpellID) and MM:isCorrectFaction(isFactionSpecific, faction) ) then
			table.insert(goodNumbers,mountListIDs[i]);
		end;
	end;
	return goodNumbers;
end;

function MM:isFlyableArea()
	if ( IsSwimming() == true ) then return 0; end;
	if ( MM:findValue(noFlyZones,GetRealZoneText()) ) then
		return false;
	end;
	local isInInstance, instanceType = IsInInstance();
	if ( isInInstance == true ) then
		if ( instanceType == "scenario" ) then
			return false;
		end;
		if ( MM:findValue(noFlyInstances,GetRealZoneText()) ) then
			return false;
		end;
	end;
	
	local allowedToFly = false;
	-- expertRider = Achievement is completed by THIS char
	local _, _, _, _, _, _, _, _, _, _, _, _, expertRider = GetAchievementInfo(890);
	if ( expertRider ) then
		allowedToFly = true;
	end;
	if ( MM:GetCurrentMapContinent() == L["Eastern Kingdoms"] ) then
		if ( L["Shimmering Expanse"] == GetRealZoneText() ) then
			if ( L["Nespirah"] == GetSubZoneText() ) then
				return false;
			end;
		end;
	end;
	if ( MM:GetCurrentMapContinent() == L["Kalimdor"] ) then
		if ( L["Wind's Redemption"] == GetRealZoneText() ) then
			return false;
		end;
	end;
	
	if ( L["Wintergrasp"] == GetRealZoneText() ) then
		local pvpID,localizedName,isActive,canQueue,startTime,canEnter = GetWorldPVPAreaInfo(worldPVPZones['Wintergrasp']);
		if ( startTime > 0 ) then
			return allowedToFly;
		else
			return false;
		end;
	end;
	if ( MM:GetCurrentMapContinent() == L["The Maelstroem"] ) then
		if ( L["Deepholm"] == GetRealZoneText() ) then
			if ( L["Crumbling Depths"] == GetSubZoneText() ) then
				return false;
			end;
		end;
	end;
	if ( MM:GetCurrentMapContinent() == L["Shaman Continent"] ) then
		if ( GetRealZoneText() == L["The Maelstrom"] ) then
			allowedToFly = false;
		end;
	end;
	if ( ( MM:GetCurrentMapContinent() == L["Nazjatar"] ) or ( MM:GetCurrentMapContinent() == L["Mechagon"] ) or ( MM:GetCurrentMapContinent() == L["Kul Tiras"] ) or ( MM:GetCurrentMapContinent() == L["Zandalar"] ) ) then
		local _, _, _, bfaPathfinder2 = GetAchievementInfo(13250);
		if ( not ( bfaPathfinder2 ) ) then
			allowedToFly = false;
		end;
	end;
	if ( not allowedToFly ) then
		return false;
	end;
	return IsFlyableArea();
end

function MM:ListMounts()
	local mountListIDs = C_MountJournal.GetMountIDs();
	local mountIDs = {};
	local mountNames = {};
	for i = 1, table.getn(mountListIDs) do
		local creatureName, creatureSpellID, icon, issummoned, isUsable, sourceType, isFavourite, isFactionSpecific, faction, hideOnChar, isCollected, mountID = C_MountJournal.GetMountInfoByID(mountListIDs[i]);
		if ( isCollected ) then
			table.insert(mountIDs, creatureSpellID);
			table.insert(mountNames, creatureName);
		end;
	end;
	local mountCount = table.getn(mountIDs);
	if ( mountCount == 0 ) then
		
	else 
		local messageScrollFrame = MM:GetMessageScrollFrame(mountCount);		
		for i = 1, mountCount do
			messageScrollFrame:AddMessage("ID: " .. mountIDs[i] .. ", Name: " .. mountNames[i]);
			-- DEFAULT_CHAT_FRAME:AddMessage("ID: " .. mountIDs[i] .. ", Name: " .. mountNames[i]);
		end;
	end;
end

function MM:ListUnknownMounts()
	local mountListIDs = C_MountJournal.GetMountIDs();
	local mountIDs = {};
	local mountNames = {};
	for i = 1, table.getn(mountListIDs) do
		local creatureName, creatureSpellID, icon, issummoned, isUsable, sourceType, isFavourite, isFactionSpecific, faction, hideOnChar, isCollected, mountID = C_MountJournal.GetMountInfoByID(mountListIDs[i]);
		if ( not ( MM:findValue(qirajRidingMounts,creatureSpellID)
			or MM:findValue(waterMounts,creatureSpellID)
			or MM:findValue(fastWaterMounts,creatureSpellID)
			or MM:findValue(groundMounts,creatureSpellID)
			or MM:findValue(flyingMounts,creatureSpellID)
			or MM:findValue(walkRidingMounts,creatureSpellID)
			or MM:findValue(chauffeuredMounts,creatureSpellID)
		) ) then
			table.insert(mountIDs,creatureSpellID);
			table.insert(mountNames,creatureName);
		end;
	end;
	local mountCount = table.getn(mountIDs);
	if ( mountCount == 0 ) then
		DEFAULT_CHAT_FRAME:AddMessage(L["All your mounts are known to this addon."]);
	else
		local messageScrollFrame = MM:GetMessageScrollFrame(mountCount);		
		for i = 1, mountCount do
			messageScrollFrame:AddMessage("ID: " .. mountIDs[i] .. ", Name: " .. mountNames[i]);
		end
	end;
end

function MM:ListMountGroup(info, value)
	local mountListIDs = C_MountJournal.GetMountIDs();
	local mountIDs = {};
	local mountNames = {};
	local group = tonumber(value);
	if ( ( group == nil) or (group < 1) or (group > 5) ) then
			DEFAULT_CHAT_FRAME:AddMessage(L["List mount group"]);
			return;
		end;
	for i = 1, table.getn(mountListIDs) do
		local creatureName, creatureSpellID, icon, issummoned, isUsable, sourceType, isFavourite, isFactionSpecific, faction, hideOnChar, isCollected, mountID = C_MountJournal.GetMountInfoByID(mountListIDs[i]);
		if ( MM:findValue(MikaMounterGlobalPrefs.mountgroups[group].mounts,creatureSpellID) ) then
			table.insert(mountIDs,creatureSpellID);
			table.insert(mountNames,creatureName);
		end;
	end;
	local mountCount = table.getn(mountIDs);
	if ( mountCount == 0 ) then
		local aMessage = MM:strsplit("<number>", L["The list <number> is empty."]);
		DEFAULT_CHAT_FRAME:AddMessage(aMessage[1]..group..aMessage[2]);
	else
		local messageScrollFrame = MM:GetMessageScrollFrame(mountCount);		
		for i = 1, mountCount do
			messageScrollFrame:AddMessage("ID: " .. mountIDs[i] .. ", Name: " .. mountNames[i]);
		end
	end;
end

-- Favourites and dislikes

function MM:ToggleFavourite(info, value)
	-- \124cff71d5ff\124Hspell:16056\124h[Ancient Frostsaber]\124h\124r
	--- |cff71d5ff|Hspell:16056|h[Ancient Frostsaber]|h|r
	if ( string.len(value) > 0 ) then
		local paramArray = MM:strsplit(":",value);
		local spellid = MM:strsplit("|",paramArray[2]);
		spellid = tonumber(spellid[1]);
		if ( MM:findValue(MikaMounterPrefs.favourites,spellid) ) then
			local index = MM:getKey(MikaMounterPrefs.favourites,spellid);
			table.remove(MikaMounterPrefs.favourites,index);
			DEFAULT_CHAT_FRAME:AddMessage(L['Removed: ']..value);
		else
			table.insert(MikaMounterPrefs.favourites,spellid);
			DEFAULT_CHAT_FRAME:AddMessage(L['Added: ']..value);
		end;
	end;
end

function MM:ToggleDislike(info, value)
	-- \124cff71d5ff\124Hspell:16056\124h[Ancient Frostsaber]\124h\124r
	--- |cff71d5ff|Hspell:16056|h[Ancient Frostsaber]|h|r
	if ( string.len(value) > 0 ) then
		local paramArray = MM:strsplit(":",value);
		local spellid = MM:strsplit("|",paramArray[2]);
		spellid = tonumber(spellid[1]);
		if ( MM:findValue(MikaMounterPrefs.dislikes,spellid) ) then
			local index = MM:getKey(MikaMounterPrefs.dislikes,spellid);
			table.remove(MikaMounterPrefs.dislikes,index);
			DEFAULT_CHAT_FRAME:AddMessage(L['Removed: ']..value);
		else
			table.insert(MikaMounterPrefs.dislikes,spellid);
			DEFAULT_CHAT_FRAME:AddMessage(L['Added: ']..value);
		end;
	end;
end

function MM:ToggleMountGroup(info, value)
	-- \124cff71d5ff\124Hspell:16056\124h[Ancient Frostsaber]\124h\124r
	--- |cff71d5ff|Hspell:16056|h[Ancient Frostsaber]|h|r
	if ( string.len(value) > 0 ) then
		local paramArray = MM:strsplit(":",value);
		local spellid = MM:strsplit("|",paramArray[2]);
		local group = MM:strsplit(" ",paramArray[1]);
		group = tonumber(group[1]);
		spellid = tonumber(spellid[1]);
		if ( ( group == nil) or (group < 1) or (group > 5) ) then
			DEFAULT_CHAT_FRAME:AddMessage(L["Toggle mount group"]);
			return;
		end;
		if ( MM:findValue(MikaMounterGlobalPrefs.mountgroups[group].mounts,spellid) ) then
			local index = MM:getKey(MikaMounterGlobalPrefs.mountgroups[group].mounts,spellid);
			table.remove(MikaMounterGlobalPrefs.mountgroups[group].mounts,index);
			DEFAULT_CHAT_FRAME:AddMessage(L['Removed: ']..value);
		else
			table.insert(MikaMounterGlobalPrefs.mountgroups[group].mounts,spellid);
			DEFAULT_CHAT_FRAME:AddMessage(L['Added: ']..value);
		end;
	end;
end

function MM:SetMountGroupName(info, value)
	-- TODO: Code...
	if ( string.len(value) > 0 ) then
		local paramArray = MM:strsplit(" ",value);
		group = tonumber(paramArray[1]);
		local remainingText = "";
		if ( ( group == nil) or (group < 1) or (group > 5) ) then
			DEFAULT_CHAT_FRAME:AddMessage(L["Toggle mount group"]);
			return;
		end;
		for i = 2, table.getn(paramArray) do
			if ( string.len(remainingText) > 0 ) then
				remainingText = remainingText .. " ";
			end;
			remainingText = remainingText .. paramArray[i];
		end;
		if ( string.len(remainingText) > 0 ) then
			MikaMounterGlobalPrefs.mountgroups[group].name = remainingText;
		end;
	end;
end


function MM:ToggleFavourites()
	if ( MikaMounterPrefs.favouritesActive ) then
		MikaMounterPrefs.favouritesActive = false;
		DEFAULT_CHAT_FRAME:AddMessage(L["Favourites are now inactive."]);
	else
		MikaMounterPrefs.favouritesActive = true;
		DEFAULT_CHAT_FRAME:AddMessage(L["Favourites are now active."]);
	end
end

function MM:ToggleDislikes()
	if ( MikaMounterPrefs.dislikesActive ) then
		MikaMounterPrefs.dislikesActive = false;
		DEFAULT_CHAT_FRAME:AddMessage(L["Dislikes are now inactive."]);
	else
		MikaMounterPrefs.dislikesActive = true;
		DEFAULT_CHAT_FRAME:AddMessage(L["Dislikes are now active."]);
	end
end

function MM:IntersectTables(table2)
	local returnTable = {};
	if ( MikaMounterPrefs.favouritesActive ) then
		local table1 = MikaMounterPrefs.favourites;
		if ( table.getn(MM:getMountNumbers(table1)) > 0 ) then
			for i = 1, table.getn(table1) do
				if ( MM:findValue(table2,table1[i]) ) then
					table.insert(returnTable,table1[i]);
				end;
			end;
		end;
		if ( table.getn(returnTable) == 0 ) then
			returnTable = table2;
		end;
	else
		if ( table.getn(returnTable) == 0 ) then
			returnTable = table2;
		end;
	end;
	if ( MikaMounterPrefs.dislikesActive ) then
		local table1 = MikaMounterPrefs.dislikes;
		if ( table.getn(returnTable) == table.getn(table2) ) then
			returnTable = {};
			for i = 1, table.getn(table2) do
				if ( not (MM:findValue(table1,table2[i])) ) then
					table.insert(returnTable,table2[i]);
				end;
			end;
		end;
	else
		if ( table.getn(returnTable) == 0 ) then
			returnTable = table2;
		end;
	end;
	return returnTable;
end

-- Oculus functions
function MM:UNIT_INVENTORY_CHANGED(event, unit)
	if ( unit == "player" ) then
		MM:CheckBind();
	end;
end
function MM:ITEM_LOCK_CHANGED(event, bag, item)
	if ( not ( item == nil ) ) then
		MM:CheckBind();
	end;
end
function MM:UNIT_PET(event, unit)
	if ( unit == "player" ) then
		MM:CheckBind();
	end;
end
function MM:UNIT_AURA(event, unit)
	if ( unit == "player" ) then
		MM:CheckBind();
	end;
end
function MM:UNIT_ENTERED_VEHICLE(event, unit)
	if ( unit == "player" ) then
		MM:CheckBind();
	end;
end
function MM:ZONE_CHANGED(event)
	MM:CheckBind();
end;

function MM:CheckBind()
	if ( InCombatLockdown() ) then
		return;
	end;
	local bSkipClear = false;
	if ( GetBindingKey("MOUNT_AUTO") ) then
		if not ( ( IsMounted() == true ) or ( CanExitVehicle() == true ) ) then
			local className, _, _ = C_PlayerInfo.GetClass(PlayerLocation:CreateFromUnit("player"));
			for bagID = 0, NUM_BAG_SLOTS do
				for slotID = 1 , GetContainerNumSlots(bagID) do
					local itemLink = GetContainerItemLink(bagID, slotID);
					if ( not (itemLink == nil) ) then
						if ( GetRealZoneText() == L["The Oculus"] ) then
							if ( ( string.find(itemLink,"item:37859:") ) or ( string.find(itemLink,"item:37815:") ) or ( string.find(itemLink,"item:37860:") ) ) then
								MM.actionbutton:SetAttribute("type","item");
								MM.actionbutton:SetAttribute("item",bagID.." "..slotID);
								SetOverrideBindingClick(MM.actionbutton, false, GetBindingKey("MOUNT_AUTO"), "MountButton", "Hotkey1");
								return;
							end;
						end;
						if ( string.find(itemLink,"item:37011:") and ( MM:getRidingSkill() > 0) ) then
							MM.actionbutton:SetAttribute("type","item");
							MM.actionbutton:SetAttribute("item",bagID.." "..slotID);
							SetOverrideBindingClick(MM.actionbutton, false, GetBindingKey("MOUNT_AUTO"), "MountButton", "Hotkey1");
							if ( not( className == "Druid" ) ) then
								return;
							end;
						end;
					end;
				end;
			end;
			if ( className == "Druid" ) then
				if ( C_Spell.DoesSpellExist(783) ) then
					MM.actionbutton:SetAttribute("type","spell");
					if ( IsIndoors() ) then
						MM.actionbutton:SetAttribute("spell", 768);
					else
						MM.actionbutton:SetAttribute("spell", 783);
					end;
					SetOverrideBindingClick(MM.actionbutton, false, GetBindingKey("MOUNT_AUTO"), "MountButton", "Hotkey1");
					return;
				end;
			end;
		end;
	end;
	ClearOverrideBindings(MM.actionbutton);
end

function MM:Nothing(info)

end;


-- Returns 75 for each earned skill by this character
function MM:getRidingSkill()
	local _, _, _, _, _, _, _, _, _, _, _, _, lowRider = GetAchievementInfo(891); -- 60% ground
	local _, _, _, _, _, _, _, _, _, _, _, _, fastRider = GetAchievementInfo(889); -- 100% ground
	local _, _, _, _, _, _, _, _, _, _, _, _, lowFlyer = GetAchievementInfo(890); -- 150% flying
	local _, _, _, _, _, _, _, _, _, _, _, _, fastFlyer = GetAchievementInfo(892); -- 280% flying
	local _, _, _, _, _, _, _, _, _, _, _, _, veryFastFlyer = GetAchievementInfo(5180); -- 310% flying
	local ridingSkill = 0;
	if ( lowRider ) then ridingSkill = ridingSkill + 75; end;
	if ( fastRider ) then ridingSkill = ridingSkill + 75; end;
	if ( lowFlyer ) then ridingSkill = ridingSkill + 75; end;
	if ( fastFlyer ) then ridingSkill = ridingSkill + 75; end;
	if ( veryFastFlyer ) then ridingSkill = ridingSkill + 75; end;
	return ridingSkill;
end;

function MM:hasSkillFor(creatureSpellID)
	local prof1, prof2, archaeology, fishing, cooking, firstAid = GetProfessions();
	if ( prof1 ) then
		local name1, _, _, _, _, _, _, _ = GetProfessionInfo(prof1);
		if ( skillMounts[creatureSpellID] == name1 ) then
			return true;
		end
	end;
	if ( prof2 ) then
		local name2, _, _, _, _, _, _, _ = GetProfessionInfo(prof2);
		if ( skillMounts[creatureSpellID] == name2 ) then
			return true;
		end
	end;
	if ( skillMounts[creatureSpellID] == L["Cloud Serpent Riding"] ) then
		local spellType, spellId = GetSpellBookItemInfo(L["Cloud Serpent Riding"]);
		if ( spellType == "SPELL" ) then
			return true;
		end;
	end;
	return (skillMounts[creatureSpellID] == nil);
end

function MM:isCorrectFaction(isFactionSpecific, faction)
	local englishFaction, localizedFaction = UnitFactionGroup("player");
	local isHordePlayerAndMount = ((faction == 0) and (englishFaction == 'Horde'));
	local isAlliancePlayerAndMount = ((faction == 1) and (englishFaction == 'Alliance'));
	return ( (isFactionSpecific == false) or isHordePlayerAndMount or isAlliancePlayerAndMount );
end;

function MM:findValue(myTable, key)
	for i = 1, table.getn(myTable) do
		if ( myTable[i] == key ) then
			return true;
		end;
	end
	return false;
end

function MM:getKey(myTable, key)
	for i = 1, table.getn(myTable) do
		if ( myTable[i] == key ) then
			return i;
		end;
	end
	return false;
end

function MM:GetCurrentMapContinent()
	local aAreaPath = {};
	local iCurrentAreaCode = C_Map.GetBestMapForUnit("player");
	tinsert(aAreaPath, iCurrentAreaCode);
	while ( not (C_Map.GetMapInfo(iCurrentAreaCode).parentMapID == 0) ) do
		iCurrentAreaCode = C_Map.GetMapInfo(iCurrentAreaCode).parentMapID;
		tinsert(aAreaPath, iCurrentAreaCode);
	end;
	local iCurrentContinentID = -1;
	if ( table.getn(aAreaPath) > 2 ) then
		iCurrentContinentID = aAreaPath[table.getn(aAreaPath)-2];
	end;
	if ( not (continentMap[iCurrentContinentID] == nil) ) then
		iCurrentContinentID = continentMap[iCurrentContinentID];
	end;
	return iCurrentContinentID;
end

function MM:strsplit(delimiter, text)
	local list = {}
	local pos = 1
	if strfind("", delimiter, 1) then -- this would result in endless loops
		error("delimiter matches empty string!")
	end
	while 1 do
		local first, last = strfind(text, delimiter, pos)
		if first then -- found?
			tinsert(list, strsub(text, pos, first-1))
			pos = last+1
		else
			tinsert(list, strsub(text, pos))
			break
		end
	end
	return list
end

function MM:OnEnable()

end

function MM:OnDisable()

end

-- The Big UI Theory...

function MM:GetMessageScrollFrame(mountCount)
	local messageFrame = CreateFrame("Frame", "MikaMounterInfoFrame", UIParent);
	messageFrame.height = 500;
	messageFrame.width = 600;
	messageFrame:SetSize(messageFrame.width, messageFrame.height);
	messageFrame:SetPoint("CENTER", UIParent, "CENTER", 0, 0);
	messageFrame:SetBackdrop({
		bgFile 		= "Interface\\DialogFrame\\UI-DialogBox-Background",
		edgeFile	= "Interface\\DialogFrame\\UI-DialogBox-Border",
		tile 		= true,
		tileSize 	= 32,
		edgeSize 	= 32,
		insets 		= { left = 8, right = 8, top = 8, bottom = 8 }
	});
	messageFrame:SetBackdropColor(0, 0, 0, 1);
	messageFrame:EnableMouse(true);
	messageFrame:EnableMouseWheel(true);
	
	local closebutton = CreateFrame("Button", nil, messageFrame, "UIPanelButtonTemplate")
	closebutton:SetScript("OnClick", function(self) HideParentPanel(self); end);
	closebutton:SetPoint("TOPRIGHT", -8, -8);
	closebutton:SetHeight(25);
	closebutton:SetWidth(25);
	closebutton:SetText('X');
	
	local messageScrollFrame = CreateFrame("ScrollingMessageFrame", messageScrollFrame, messageFrame);
	messageScrollFrame:SetPoint("CENTER", 15, -8);
	messageScrollFrame:SetSize(570, 410);
	messageScrollFrame:SetFontObject("GameFontNormal");
	messageScrollFrame:SetTextColor(1, 1, 1, 1);
	messageScrollFrame:SetJustifyH("LEFT");
	messageScrollFrame:SetHyperlinksEnabled(true);
	messageScrollFrame:SetFading(false);
	messageScrollFrame:SetMaxLines(800);
	
	
	local scrollBar = CreateFrame("Slider", "MikaMounterInfoScrollBar", messageScrollFrame, "UIPanelScrollBarTemplate");

	scrollBar:ClearAllPoints();
	scrollBar:SetPoint("RIGHT", messageScrollFrame, "RIGHT", -8, 0);
	scrollBar:SetSize(30, 410);
	local minScroll = 0;
	if ( mountCount > 34 ) then
		minScroll = 34;
	end;
	scrollBar:SetMinMaxValues(minScroll, mountCount);
	scrollBar:SetValueStep(1);
	scrollBar.scrollStep = 1;
	scrollBar:SetScript("OnValueChanged", function(self, value)
		value = math.floor(value+0.5);
		messageScrollFrame:SetScrollOffset(select(2, scrollBar:GetMinMaxValues()) - value);
	end);
	
	scrollBar:SetValue(select(2, scrollBar:GetMinMaxValues()));

	messageFrame:SetScript("OnMouseWheel", function(self, delta)
	
		local cur_val = scrollBar:GetValue();
		local min_val, max_val = scrollBar:GetMinMaxValues();

		if delta < 0 and cur_val < max_val then
			cur_val = math.min(max_val, cur_val + 5);
			scrollBar:SetValue(cur_val);
		elseif delta > 0 and cur_val > min_val then
			cur_val = math.max(min_val, cur_val - 5);
			scrollBar:SetValue(cur_val);
		end;
	end);
	return messageScrollFrame;
end;
